#include "Sphere.h"
#include "Thor.h"
#include "Vector3D.h"
#include "Material.h"
#include "Light.h"
#include <QMainWindow>
#include <QFile>

///     / XML
#define XML true
///     /  
#define Bin false

///     
#define WR true
///     
#define RE false

//class QFile;
/**
@class Serializer
  ,  , ,
3  , 6   7   .
*/
class Serializer
{
public:
        ///   -    
        QFile * File;
        ///   - - /  : 'false'  , 'true'  
        bool readWrite;
        ///   -      : 'false'  XML, 'true'  
        bool format;

        ///   -   
        QString FileName;

        /// 
        Serializer();
        /// 
        ~Serializer();

        ///   ,  .
        /// @param  FileName    
        /// @return  -    
        virtual bool Start(QString FileName) = 0;

        ///   ,  .
        /// @param  Value    
        /// @param  Name    (  "String")
        virtual void SerStr(char * Value, char * Name = "String") = 0;
        ///   ,   .
        /// @param  Value     
        /// @param  Name    (  "Bool")
        virtual void SerBool(bool &Value, char * Name = "Bool") = 0;
        ///   ,   .
        /// @param  Value     
        /// @param  Name    (  "Int")
        virtual void SerInt(int &Value, char * Name = "Int") = 0;
        ///   ,   .
        /// @param  Value     
        /// @param  Name    (  "Float")
        virtual void SerFloat(float &Value, char * Name = "Float") = 0;
        ///   ,   .
        /// @param  Value     
        /// @param  Name    (  "Vector")
        virtual void SerVec(Vector3D &Value, char * Name = "Vector") = 0;
        /// ,   .
        /// @param  Width     
        /// @param  Height     
        /// @param  Name    (  "Screen")
        void SerPic(int &Width, int &Height, char *Name = "Screen");
        /// ,   .
        /// @param  Camera     
        /// @param  Name    (  "Camera")
        void SerCam(Vector3D &Camera, char * Name = "Camera");
        /// ,   .
        /// @param  Material      
        /// @param  Name    (  "Material")
        void SerMat(Mater &Material, char * Name = "Material");
        /// ,  .
        /// @param  Sph      
        /// @param  Name    (  "Sphere")
        void SerSph(Sphere &Sph, char *Name = "Sphere");
        /// ,  .
        /// @param  Th      
        /// @param  Name    (  "Thor")
        void SerThor(Thor &Th, char *Name = "Thor");
        /// ,   .
        /// @param  Li       
        /// @param  Name    (  "Light")
        void SerLight(Light &Li, char *Name = "Light");

        ///   ,  .
        virtual void End() = 0;
};


/**
@class XMLS
    Serializer,       XML ,
 , , 3  , 7 .
*/
class XMLS : public Serializer
{
public:
        /// 
	XMLS();
        /// 
	~XMLS();

        /// ,  .
        /// @param  FileName    
        /// @return  -    
        bool Start(QString FileName);

        /// ,  .
        /// @param  Value    
        /// @param  Name    (  "String")
        void SerStr(char * Value, char * Name = "String");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Bool")
        void SerBool(bool &Value, char * Name = "Bool");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Int")
        void SerInt(int &Value, char * Name = "Int");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Float")
        void SerFloat(float &Value, char * Name = "Float");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Vector")
        void SerVec(Vector3D &Value, char * Name = "Vector");

        /// ,  .
        void End();
};

/**
@class XMLL
    Serializer,       XML ,
 , , 3  , 7 .
*/
class XMLL : public Serializer
{
public:
        /// 
        XMLL();
        /// 
        ~XMLL();

        /// ,  .
        /// @param  FileName    
        /// @return  -    
        bool Start(QString FileName);

        /// ,  .
        /// @param  Value    
        /// @param  Name    (  "String")
        void SerStr(char * Value, char * Name = "String");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Bool")
        void SerBool(bool &Value, char * Name = "Bool");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Int")
        void SerInt(int &Value, char * Name = "Int");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Float")
        void SerFloat(float &Value, char * Name = "Float");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Vector")
        void SerVec(Vector3D &Value, char * Name = "Vector");

        /// ,  .
        void End();
};

/**
@class BinS
    Serializer,        ,
 , , 3  , 7 .
*/

class BinS : public Serializer
{
public:
    /// 
    BinS();
    /// 
    ~BinS();

        /// ,  .
        /// @param  FileName    
        /// @return  -    
        bool Start(QString FileName);

        /// ,  .
        /// @param  Value    
        /// @param  Name    (  "String")
        void SerStr(char * Value, char * Name = "String");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Bool")
        void SerBool(bool &Value, char * Name = "Bool");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Int")
        void SerInt(int &Value, char * Name = "Int");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Float")
        void SerFloat(float &Value, char * Name = "Float");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Vector")
        void SerVec(Vector3D &Value, char * Name = "Vector");

        /// ,  .
        void End();
};

/**
@class BinL
    Serializer,        ,
 , , 3  , 7 .
*/
class BinL : public Serializer
{
public:
    /// 
    BinL();
    /// 
    ~BinL();

        /// ,  .
        /// @param  FileName    
        /// @return  -    
        bool Start(QString FileName);

        /// ,  .
        /// @param  Value    
        /// @param  Name    (  "String")
        void SerStr(char * Value, char * Name = "String");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Bool")
        void SerBool(bool &Value, char * Name = "Bool");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Int")
        void SerInt(int &Value, char * Name = "Int");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Float")
        void SerFloat(float &Value, char * Name = "Float");
        /// ,   .
        /// @param  Value     
        /// @param  Name    (  "Vector")
        void SerVec(Vector3D &Value, char * Name = "Vector");

        /// ,  .
        void End();
};
